
#include <stdio.h>

#ifdef SOLARIS
#	define __EXTENSIONS__  1
#	include <thread.h>
#	define _mut_ mutex_t *
#	define _thr_ thread_t
	typedef void* (*oberon_proc)(void *);
#else
#	include <pthread.h>
#	define _mut_ pthread_mutex_t *
#	define _thr_ pthread_t
#	ifdef PowerPC_Oberon_Compiler
		typedef struct { int pc, sb; } *oberon_proc;
#	else
		typedef	int (*oberon_proc)();
#	endif
#endif


extern _mut_	_mtx_init( );
extern void	_mtx_destroy( _mut_ mtx );
extern void	_mtx_lock(    _mut_ mtx );
extern void	_mtx_unlock(  _mut_ mtx );

#ifdef PowerPC_Oberon_Compiler
extern _thr_	_thr_start( int PC, int SB, int len );
#else
extern _thr_	_thr_start( oberon_proc p, int len );
#endif

extern _thr_	_thr_this( );
extern void	_thr_sleep( int ms );
extern void	_thr_pass( );
extern void	_thr_exit( );
extern void	_thr_sendsig( _thr_ thr, int sig );
extern void	_thr_suspend( _thr_ thr );
extern void	_thr_resume(  _thr_ thr );
extern void	_thr_setprio( _thr_ thr, int prio );
extern int 	_thr_getprio( _thr_ thr );
extern void	_thr_maxprio( );
extern void	_thr_oldprio( );
extern void	_thr_kill( _thr_ thr );

extern int 	_thr_initialize( int *low, int* high );


