
/***********
 * OberonTypes.h
 * C definition of basic Oberon types and type descriptor formats
 * Marc-Michael Brandis, 22.8.91 / 29.8.91
 ***********/

#ifndef _I_OBERONTYPES
#define _I_OBERONTYPES

#include "POP2limits.h"

/* basic Oberon types */
typedef unsigned char CHAR;
typedef unsigned char BYTE;
typedef char SHORTINT;
typedef short int INTEGER;
typedef int LONGINT;
typedef unsigned int SET;
typedef unsigned char BOOLEAN;

#define FALSE 0
#define TRUE 1

typedef void* ADDRESS;

typedef struct {
	LONGINT PC, SB;
} PROC;

/* type descriptor formats */
typedef struct {
	/* PROC methods[nofmethods],
		starting at offset -8-MaxExts*4 in negative direction */
	/* ADDRESS basetags[MaxExts],
		starting at offset -8 in negative direction */
	/* ADDRESS tag, at offset -4 */
	LONGINT recsize;
	LONGINT ptroff;
	/* ptroff is actually an array terminated by the value -4 - nofptr*4 */
} TypeDesc;

typedef TypeDesc* Tag;

typedef CHAR TypeName[32];

typedef struct {
	LONGINT tdsize;
	LONGINT ptroff;	/* contains always -4 */
	Tag tag;
	SHORTINT pad[3];
	SHORTINT ext0;
	TypeName typename;
	ADDRESS Module;
} SuperDesc;

typedef struct {
	ADDRESS lastelem, reserved, firstelem;
	LONGINT len;
} ArrayDesc;

typedef SuperDesc* SuperTag;
typedef TypeDesc SystemTD;

#define TagMask 0xfffffffe

/* macros to access the special fields */
#define TAG(obj) (((long int *)&(obj))[-1])
#define PTROFF(tdesc, nr) (((long int *)&((tdesc).ptroff))[nr])
#define BASETAG(tdesc, nr) (((long int *)&(tdesc))[-2-nr])
#define METHOD(tdesc, nr) (*((PROC *)&(((long int *)&(tdesc))[-3-MaxExts-nr*2])))

#endif

