/*
 *  C interface for Oberon trap handling
 *  G. Feldmann 28.1.97
 *      26.03.1999      glibc2.1
 *      19.08.2002      Darwin 5.1
 *	19.01.2003	Darwin 6.2
 */

#include <stdio.h>
#include <setjmp.h>
#include <signal.h>

extern void* oberonTrapHandler;


/* static void traphandler(int sig, void *sip, struct sigcontext *ctx) { */
static void traphandler(int sig, struct __siginfo *sip, void *ctx) {
	long *p,pc,sb;
	int i;

	/*printf("C traphandler: received signal %d \n", sig);*/
	p = (long *)oberonTrapHandler;
	pc = *p++; sb = *p;
	i = CallOberon(pc, sb, sig, ctx);


	/* Trap has been a watchdog alarm, mousekeys still pressed 
	   continue processing at intrrupted position 
	 */
	return;
}

static void installHandler(int sig) {
	struct sigaction act;
	sigset_t mask;

	sigemptyset(&mask);
	act.sa_flags = SA_NOCLDSTOP|SA_SIGINFO;
	act.sa_mask = mask;
	act.sa_handler = traphandler;
	if (sigaction( sig, &act, NULL ) != 0) {
		perror("sigaction");
	}
}

void SetupTrapHandler () {
	int i;

	for (i = 1; i <= 15; i++) {
	    if (i != 9) installHandler( i );
	}
}


