/*
 *  C interface for Oberon trap handling
 *  G. Feldmann 28.1.97
 * 	26.3.99 	glibc2.1
 */

#include <stdio.h>
#include <setjmp.h>
#include <signal.h>

extern void* oberonTrapHandler;

extern jmp_buf buf;

static void traphandler(int sig, void *ctx) {
	
	long *p,pc,sb;
	int i;

	p = (long *)oberonTrapHandler;
	pc = *p++; sb = *p;
	i = CallOberon(pc, sb, sig, ctx);  /* call Oberon trap handler */

	if (i) longjmp(buf, 1);  /* restart Oberon loop */
	
	/* Trap handler returned FALSE,
	   continue processing at intrrupted position 
	 */
	return;
}

static void installHandler(int sig) {
	struct sigaction act;
	__sigset_t mask;

	sigemptyset(&mask);
	act.sa_flags = SA_NOCLDSTOP;
	act.sa_mask = mask;
	act.sa_handler = (__sighandler_t)traphandler;
	if (sigaction( sig, &act, NULL ) != 0) {
		perror("sigaction");
	}
}

void initTraps() {
	int i;

	for (i = 1; i <= 15; i++) {
	    if (i != 9) installHandler( i );
	}
}

/********************************************
 * implemented in assembler, see ATrapHandler.s
 * called from within Oberon loop once
 *
 * void SetupTrapHandler () {
 *
 *	initTraps();
 *	if (setjmp(buf, 1 ) == 0) {
 *	}
 * }
 ******************************************/

